double NearestNeighbor(Image *in,double uv[2]){
  int in_i =  ((int)(uv[1]));
  int in_j =  ((int)(uv[0]));
  int in_i2 =  getImage_Coordinate(in->sy,uv[1]);
  int in_j2 =  getImage_Coordinate(in->sx,uv[0]);
  
  double p0[2];
  p0[0] = ((double)(in_j));
  p0[1] = ((double)(in_i));
  
  double minval = in->img[in_i2][in_j2];
  double mindist = dist(p0,uv);
  p0[0] = ((double)(in_j))+1.0;
  p0[1] = ((double)(in_i));
  double dval = dist(p0,uv);
  if(mindist>dval){
    mindist = dval;
    in_i2 =  getImage_Coordinate(in->sy,p0[1]);
    in_j2 =  getImage_Coordinate(in->sx,p0[0]);
    minval = in->img[in_i2][in_j2];
  }
  
  p0[0] = ((double)(in_j));
  p0[1] = ((double)(in_i))+1.0;
  dval = dist(p0,uv);
  if(mindist>dval){
    mindist = dval;
    in_i2 =  getImage_Coordinate(in->sy,p0[1]);
    in_j2 =  getImage_Coordinate(in->sx,p0[0]);
    minval = in->img[in_i2][in_j2];
  }
  p0[0] = ((double)(in_j))+1.0;
  p0[1] = ((double)(in_i))+1.0;
  dval = dist(p0,uv);
  if(mindist>dval){
    mindist = dval;
    in_i2 =  getImage_Coordinate(in->sy,p0[1]);
    in_j2 =  getImage_Coordinate(in->sx,p0[0]);
    minval = in->img[in_i2][in_j2];
  }
  return minval;
}
double LinearInterpolation(Image *in,double uv[2]){
  
  int in_i0 =  ((int)(uv[1]));if(in_i0<0)in_i0=0;if(in_i0>in->sy-1)in_i0=in->sy-1;
  int in_j0 =  ((int)(uv[0]));if(in_j0<0)in_j0=0;if(in_j0>in->sx-1)in_j0=in->sx-1;
  
  int in_i1 =  ((int)(uv[1]));if(in_i1<0)in_i1=0;if(in_i1>in->sy-1)in_i1=in->sy-1;
  int in_j1 =  ((int)(uv[0]))+1;if(in_j1>in->sx-1)in_j1=in->sx-1;if(in_j1<0)in_j1=0;
  
  int in_i2 =  ((int)(uv[1]))+1;if(in_i2>in->sy-1)in_i2=in->sy-1;if(in_i2<0)in_i2=0;
  int in_j2 =  ((int)(uv[0]));if(in_j2<0)in_j2=0;if(in_j2>in->sx-1)in_j2=in->sx-1;
  
  int in_i3 =  ((int)(uv[1]))+1;if(in_i3>in->sy-1)in_i3=in->sy-1;if(in_i3<0)in_i3=0;
  int in_j3 =  ((int)(uv[0]))+1;if(in_j3>in->sx-1)in_j3=in->sx-1;if(in_j3<0)in_j3=0;
  

  double alpha1 = fabs(uv[0]-((double)(in_j0)));
  
  double f1 = alpha1*in->img[in_i1][in_j1]+(1.0-alpha1)*in->img[in_i0][in_j0];
  double f2 = alpha1*in->img[in_i3][in_j3]+(1.0-alpha1)*in->img[in_i2][in_j2];
  double alpha2 = fabs(uv[1]-((double)(in_i0)));
  double f3 = (1.0-alpha2)*f1+alpha2*f2;
  return f3;
    
}


//4x4 Cubic
double CK81(double ddx){// Cubic Function
  if(0.0<=ddx&&ddx<1.0){
    return (ddx*ddx*(1.5*ddx-2.5)+1.0);
  }else if(1.0<=ddx&&ddx<2){
    return (ddx*(ddx*(-0.5*ddx+2.5)-4.0)+2.0);
  }else{
    return 0.0;
    
  }
}


double CubicInterpolation(Image *in,double uv[2]){
  int in_i =  getImage_Coordinate(in->sy,uv[1]);
  int in_j =  getImage_Coordinate(in->sx,uv[0]);
  int i,j;
  int imin = in_i-1;if(imin<0)imin=0;
  int imax = in_i+2;if(imax>in->sy-1)imax=in->sy-1;
  int jmin = in_j-1;if(jmin<0)jmin=0;
  int jmax = in_j+2;if(jmax>in->sx-1)jmax=in->sx-1;
  double val =0.0;
  double wsum =0.0;
  for(i=imin;i<=imax;i++){
    double wy = CK81(fabs(uv[1]-((double)(i))));
    
    for(j=jmin;j<=jmax;j++){
      double weight = wy*CK81(fabs(uv[0]-((double)(j))));
      wsum += weight;
      val += weight*in->img[i][j];
    }
  }
  if(wsum<=0.0)wsum=1.0;
  return (val/wsum);
}







